import { Component, Input, Output, EventEmitter } from '@angular/core';
import { SearchResultDTO } from 'app/shared/model/search/search-result-dto.model';

@Component({
  selector: 'jhi-multi-select-dropdown-exercise',
  templateUrl: './multi-select-dropdown-exercise.component.html',
  styleUrls: ['./multi-select-dropdown-exercise.component.scss'],
})
export class MultiSelectDropdownExerciseComponent {
  @Input() list: SearchResultDTO[] | undefined;

  @Output() shareExercise = new EventEmitter();

  @Input() checkedList: string[] | undefined;
  currentSelected!: SearchResultDTO;

  search = '';

  getSelectedValue(status: boolean, value: SearchResultDTO) {
    if (status) {
      this.checkedList = [];
      this.checkedList.push(value.metadata.title);
    } else {
      this.checkedList = [];
    }

    this.currentSelected = value;

    this.shareIndividualStatus();
  }

  shareIndividualStatus() {
    this.shareExercise.emit(this.currentSelected);
  }
}
