import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { UserRouteAccessService } from 'app/core/auth/user-route-access.service';
import { ReviewHistoryEntryComponent } from '../list/review-history-entry.component';
import { ReviewHistoryEntryDetailComponent } from '../detail/review-history-entry-detail.component';
import { ReviewHistoryEntryUpdateComponent } from '../update/review-history-entry-update.component';
import { ReviewHistoryEntryRoutingResolveService } from './review-history-entry-routing-resolve.service';

const reviewHistoryEntryRoute: Routes = [
  {
    path: '',
    component: ReviewHistoryEntryComponent,
    canActivate: [UserRouteAccessService],
  },
  {
    path: ':id/view',
    component: ReviewHistoryEntryDetailComponent,
    resolve: {
      reviewHistoryEntry: ReviewHistoryEntryRoutingResolveService,
    },
    canActivate: [UserRouteAccessService],
  },
  {
    path: 'new',
    component: ReviewHistoryEntryUpdateComponent,
    resolve: {
      reviewHistoryEntry: ReviewHistoryEntryRoutingResolveService,
    },
    canActivate: [UserRouteAccessService],
  },
  {
    path: ':id/edit',
    component: ReviewHistoryEntryUpdateComponent,
    resolve: {
      reviewHistoryEntry: ReviewHistoryEntryRoutingResolveService,
    },
    canActivate: [UserRouteAccessService],
  },
];

@NgModule({
  imports: [RouterModule.forChild(reviewHistoryEntryRoute)],
  exports: [RouterModule],
})
export class ReviewHistoryEntryRoutingModule {}
