import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { QueryParamModule } from '@ngqp/core';
import { ExerciseModule } from 'app/exercise/exercise.module';
import { SharedModule } from 'app/shared/shared.module';
import { InfiniteScrollModule } from 'ngx-infinite-scroll';

import { BookmarkInfoComponent } from '../exercise/bookmarkInfo/bookmarkInfo.component';

import { SearchInputComponent } from './search-input/search-input.component';
import { SearchComponent } from './search.component';
import { SEARCH_ROUTE } from './search.route';

@NgModule({
  imports: [RouterModule.forChild([SEARCH_ROUTE]), SharedModule, QueryParamModule, InfiniteScrollModule, ExerciseModule],
  declarations: [SearchComponent, SearchInputComponent, BookmarkInfoComponent],
  exports: [SearchComponent],
})
export class SearchModule {}
